/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.mangue.client.gui.cir;

import java.awt.BorderLayout;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.mangue.common.utilities.CocktailConstantes;
import org.cocktail.mangue.common.utilities.CocktailIcones;
import org.cocktail.mangue.modele.FicheSynthese;
import org.cocktail.mangue.modele.mangue.cir.EOCirCarriereData;

import com.webobjects.eointerface.EODisplayGroup;


/**
 *
 * @author  cpinsard
 */
public class SequenceCIRView extends JFrame {

    /**
	 * 
	 */
	private static final long serialVersionUID = -6195866169790317637L;

	protected EODisplayGroup eodRubriques, eodSousRubriques;
	protected ZEOTable myEOTableRubriques, myEOTableSousRubriques;
	protected ZEOTableModel myTableModelRubriques, myTableModelSousRubriques;
	protected TableSorter myTableSorterRubriques, myTableSorterSousRubriques;


	/** Creates new form TemplateJDialog */
    public SequenceCIRView(java.awt.Frame parent, boolean modal, EODisplayGroup dgRubriques, EODisplayGroup dgSousRubriques) {
        
        eodRubriques = dgRubriques;
        eodSousRubriques = dgSousRubriques;
        
        initComponents();
        initGui();
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        tfTitre = new javax.swing.JTextField();
        viewSequenceCIR = new javax.swing.JPanel();
        viewTableRubriques = new javax.swing.JPanel();
        viewTableSousRubriques = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        console = new javax.swing.JTextArea();
        btnCalculer = new javax.swing.JButton();
        tfInfosFichier = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("GESTION DES ROLES");

        tfTitre.setBackground(new java.awt.Color(153, 153, 255));
        tfTitre.setEditable(false);
        tfTitre.setFont(new java.awt.Font("Times New Roman", 0, 14));
        tfTitre.setForeground(new java.awt.Color(255, 255, 204));
        tfTitre.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfTitre.setText("SYNTHESE CARRIERE CIR");
        tfTitre.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        tfTitre.setFocusable(false);
        tfTitre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfTitreActionPerformed(evt);
            }
        });

        viewSequenceCIR.setPreferredSize(new java.awt.Dimension(500, 557));

        viewTableRubriques.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableRubriques.setLayout(new java.awt.BorderLayout());

        viewTableSousRubriques.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableSousRubriques.setLayout(new java.awt.BorderLayout());

        console.setColumns(20);
        console.setForeground(new java.awt.Color(51, 51, 51));
        console.setLineWrap(true);
        console.setRows(5);
        jScrollPane1.setViewportView(console);

        btnCalculer.setText("Calculer");
        btnCalculer.setToolTipText("");

        tfInfosFichier.setBackground(new java.awt.Color(255, 255, 255));
        tfInfosFichier.setEditable(false);
        tfInfosFichier.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfInfosFichier.setBorder(null);
        tfInfosFichier.setFocusable(false);

        org.jdesktop.layout.GroupLayout viewSequenceCIRLayout = new org.jdesktop.layout.GroupLayout(viewSequenceCIR);
        viewSequenceCIR.setLayout(viewSequenceCIRLayout);
        viewSequenceCIRLayout.setHorizontalGroup(
            viewSequenceCIRLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(viewSequenceCIRLayout.createSequentialGroup()
                .addContainerGap()
                .add(viewSequenceCIRLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 751, Short.MAX_VALUE)
                    .add(tfInfosFichier, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 751, Short.MAX_VALUE)
                    .add(viewSequenceCIRLayout.createSequentialGroup()
                        .add(viewTableRubriques, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 179, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(viewTableSousRubriques, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 562, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, btnCalculer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 136, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        viewSequenceCIRLayout.setVerticalGroup(
            viewSequenceCIRLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, viewSequenceCIRLayout.createSequentialGroup()
                .addContainerGap()
                .add(tfInfosFichier, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewSequenceCIRLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(viewTableRubriques, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 414, Short.MAX_VALUE)
                    .add(viewTableSousRubriques, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 414, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(btnCalculer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tfTitre, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 906, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(viewSequenceCIR, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 771, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(tfTitre, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewSequenceCIR, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 590, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(81, Short.MAX_VALUE))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-932)/2, (screenSize.height-775)/2, 932, 775);
    }// </editor-fold>//GEN-END:initComponents

    private void tfTitreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfTitreActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_tfTitreActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
            	SequenceCIRView dialog = new SequenceCIRView(new javax.swing.JFrame(), true, null, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
					public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCalculer;
    private javax.swing.JTextArea console;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextField tfInfosFichier;
    private javax.swing.JTextField tfTitre;
    private javax.swing.JPanel viewSequenceCIR;
    protected javax.swing.JPanel viewTableRubriques;
    protected javax.swing.JPanel viewTableSousRubriques;
    // End of variables declaration//GEN-END:variables

    private void initGui() {

    	btnCalculer.setIcon(CocktailIcones.ICON_CALCULATE_16);
    	
		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();

    	ZEOTableModelColumn	col = new ZEOTableModelColumn(eodRubriques, EOCirCarriereData.CIRCD_RUBRIQUE_KEY, "Rubriques", 150);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	
		myTableModelRubriques = new ZEOTableModel(eodRubriques, myCols);
		myTableSorterRubriques = new TableSorter(myTableModelRubriques);

		myEOTableRubriques = new ZEOTable(myTableSorterRubriques);
		//myEOTable.addListener(myListenerContrat);
//		myTableSorterRubriques.setTableHeader(myEOTableRubriques.getTableHeader());		

		myEOTableRubriques.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableRubriques.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableRubriques.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableRubriques.setLayout(new BorderLayout());
		viewTableRubriques.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableRubriques.removeAll();
		viewTableRubriques.add(new JScrollPane(myEOTableRubriques), BorderLayout.CENTER);


		myCols = new Vector<ZEOTableModelColumn>();

    	col = new ZEOTableModelColumn(eodSousRubriques, "cle", "Clé", 50);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);
    	col = new ZEOTableModelColumn(eodSousRubriques, "valeur", "Valeur", 150);
    	col.setAlignment(SwingConstants.LEFT);
    	myCols.add(col);

		myTableModelSousRubriques = new ZEOTableModel(eodSousRubriques, myCols);
		myTableSorterSousRubriques = new TableSorter(myTableModelSousRubriques);

		myEOTableSousRubriques = new ZEOTable(myTableSorterSousRubriques);
		//myEOTable.addListener(myListenerContrat);
		//myTableSorterSousRubriques.setTableHeader(myEOTableSousRubriques.getTableHeader());		

		myEOTableSousRubriques.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableSousRubriques.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableSousRubriques.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableSousRubriques.setLayout(new BorderLayout());
		viewTableSousRubriques.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableSousRubriques.removeAll();
		viewTableSousRubriques.add(new JScrollPane(myEOTableSousRubriques), BorderLayout.CENTER);
		
    }
	public EODisplayGroup getEodRubriques() {
		return eodRubriques;
	}
	public void setEodRubriques(EODisplayGroup eodRubriques) {
		this.eodRubriques = eodRubriques;
	}
	public EODisplayGroup getEodSousRubriques() {
		return eodSousRubriques;
	}
	public void setEodSousRubriques(EODisplayGroup eodSousRubriques) {
		this.eodSousRubriques = eodSousRubriques;
	}
	public ZEOTable getMyEOTableRubriques() {
		return myEOTableRubriques;
	}
	public void setMyEOTableRubriques(ZEOTable myEOTableRubriques) {
		this.myEOTableRubriques = myEOTableRubriques;
	}
	public ZEOTable getMyEOTableSousRubriques() {
		return myEOTableSousRubriques;
	}
	public void setMyEOTableSousRubriques(ZEOTable myEOTableSousRubriques) {
		this.myEOTableSousRubriques = myEOTableSousRubriques;
	}
	public javax.swing.JTextArea getConsole() {
		return console;
	}
	public void setConsole(javax.swing.JTextArea console) {
		this.console = console;
	}
	public javax.swing.JTextField getTfTitre() {
		return tfTitre;
	}
	public void setTfTitre(javax.swing.JTextField tfTitre) {
		this.tfTitre = tfTitre;
	}
	public javax.swing.JPanel getViewSequenceCIR() {
		return viewSequenceCIR;
	}
	public void setViewSequenceCIR(javax.swing.JPanel viewSequenceCIR) {
		this.viewSequenceCIR = viewSequenceCIR;
	}
	public javax.swing.JTextField getTfInfosFichier() {
		return tfInfosFichier;
	}
	public void setTfInfosFichier(javax.swing.JTextField tfInfosFichier) {
		this.tfInfosFichier = tfInfosFichier;
	}
	public javax.swing.JButton getBtnCalculer() {
		return btnCalculer;
	}
	public void setBtnCalculer(javax.swing.JButton btnCalculer) {
		this.btnCalculer = btnCalculer;
	}
}
